package core.tools;

import java.awt.Color;
import java.util.HashSet;
import java.util.Set;

import pedviz.algorithms.filter.Filter;
import pedviz.algorithms.filter.NumberCondition;
import pedviz.algorithms.filter.TextCondition;
import pedviz.graph.Graph;
import pedviz.graph.Node;
import pedviz.view.GraphView;
import pedviz.view.animations.BlinkAnimation;
import view.tools.OldFilterView;
import view.tools.ToolView;
import core.Application;
import core.AppController;
import java.util.*;

public class OldFilterController implements ToolController {

	private Vector<BlinkAnimation> animations;
	
	private boolean filterUsed = false;

	public void init(ToolView sender){
		
	}
	
	public OldFilterController() {
		animations = new Vector<BlinkAnimation>();

	}

	public void resetPressed(ToolView sender) {

		AppController controller = Application.getInstance().getController();

		for (BlinkAnimation animation : animations) {
			animation.stop();
		}
		animations.clear();

		for (GraphView view : controller.getGraphViews()) {
			view.showAll();
		}
		
		filterUsed = false;
	}

	public void updatePressed(ToolView sender) {

		AppController controller = Application.getInstance().getController();

		OldFilterView filter = (OldFilterView) sender;
		Filter myFilter = new Filter();
		myFilter.setOperator(filter.getSelectedMode());
		for (int i = 0; i < filter.getConditions(); i++) {
			if (!filter.getTrait(i).equals("-----")) {
				try {
					double min = Double.parseDouble(filter.getMinValue(i));
					double max = Double.parseDouble(filter.getMaxValue(i));
					myFilter.addCondition(new NumberCondition(filter
							.getTrait(i), filter.getComperator(i), min, max));

				} catch (Exception e) {
					myFilter.addCondition(new TextCondition(filter.getTrait(i),
							filter.getComperator(i), filter.getMinValue(i),
							filter.getMaxValue(i)));

				}
			}
		}

		for (BlinkAnimation animation : animations) {
			animation.stop();
		}
		animations.clear();

		for (GraphView view : controller.getGraphViews()) {
			view.showAll();
		}

		Set<Node> test = new HashSet<Node>();
		test.addAll(myFilter.execute(controller.getGraph()));

		if (filter.getMode() == 0) {
			for (GraphView view : controller.getGraphViews()) {
				view.hideAll();
			}
			for (Node node : test) {
				for (GraphView view : controller.getGraphViews()) {
					view.show(node);
				}
			}
		}

		if (filter.getMode() == 1) {
			for (GraphView view : controller.getGraphViews()) {
				BlinkAnimation animation = new BlinkAnimation(view, test,
						Color.RED, Color.RED);
				animation.setInterval(500);
				animation.start();
				animations.add(animation);
			}

		}
		
		filterUsed = true;
	}

	public void afterGraphLoaded(ToolView sender, Graph graph) {
		AppController controller = Application.getInstance().getController();
		OldFilterView filter = (OldFilterView) sender;
		filter.setLookUpTable(controller.getLookUpTable());
		filter.setTraits(controller.getTraits());
	}
	
	public void afterGraphSelected(ToolView sender, Graph graph){
		if (filterUsed){
			updatePressed(sender);
		}
	}


}
