package view.dialogs;

import view.dialogs.*;
import core.*;
import pedviz.algorithms.*;

import java.awt.Frame;
import javax.swing.*;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.*;

import java.awt.BorderLayout;
import java.util.*;
public class DialogErrors extends Dialog  {

	private JTree tree;

	DefaultMutableTreeNode errorNode;
	
	public DialogErrors(Frame parent) {
		super(parent, "Errors");
		setSize(600, 400);
		errorNode = new DefaultMutableTreeNode("Errors (0)");
		tree = new JTree(errorNode);

		JScrollPane pane = new JScrollPane(tree);
		getContainer().setLayout(new BorderLayout());
		getContainer().add(pane, BorderLayout.CENTER);
		
		getOkButton().setText("AutoRepair");
	}

	@Override
	public boolean execute() {
		return super.execute();
	}

	
	public void setErrors(Vector<GraphError> errors){
		errorNode.removeAllChildren();
		errorNode.setUserObject("Errors (" + errors.size()
				+ " items)");

		for (GraphError i : errors) {
			errorNode.add(new DefaultMutableTreeNode(i));
		}
		int row = 0;
		while (row < tree.getRowCount()) {
			tree.expandRow(row);
			row++;
		}
		tree.updateUI();
	}

}
