package view.tools;

import javax.swing.*;
import javax.swing.border.EmptyBorder;

import java.util.*;
import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import core.*;

public class ConditionView implements PanelListItem, ItemListener {

	String[] modes = new String[] { "equals", "not equals", "greater",
			"lesser", "between", "not between" };

	Vector<String> traits;

	HashMap<String, Vector<String>> values;

	DefaultComboBoxModel traitModel;

	JComboBox value;

	JComboBox value2;

	JComboBox mode;

	JComboBox trait;

	JPanel container;

	public ConditionView() {
		traitModel = new DefaultComboBoxModel();
	}

	public void createUI(JPanel container) {
		this.container = container;
		GridBagLayout layout = new GridBagLayout();
		container.setLayout(layout);
		// setBorder(new EmptyBorder(2,2,2,2));
		GridBagConstraints constLabel = new GridBagConstraints();
		constLabel.ipadx = 3;
		constLabel.gridx = 0;
		constLabel.gridy = 0;
		constLabel.weightx = 1;
		constLabel.weighty = 0;
		constLabel.insets = new Insets(2, 2, 2, 2);
		constLabel.fill = GridBagConstraints.HORIZONTAL;

		trait = new JComboBox();
		trait.setModel(traitModel);
		trait.addItemListener(this);
		container.add(trait, constLabel);
		constLabel.weightx = 0;
		mode = new JComboBox(modes);
		mode.addItemListener(this);
		constLabel.gridx = 1;
		container.add(mode, constLabel);
		constLabel.weightx = 0.5;
		value = new JComboBox();
		constLabel.gridx = 2;
		container.add(value, constLabel);

		value2 = new JComboBox();
		constLabel.gridx = 3;
		container.add(value2, constLabel);
		
		if (traits != null && traits.size() > 0) {
			value.removeAllItems();
			value2.removeAllItems();
			if (values != null) {
				if (values.get(traitModel.getSelectedItem().toString()) != null)
					for (Object o : values.get(traits.get(0))) {
						value.addItem(o.toString());
						value2.addItem(o.toString());
					}
			}

			// maxField[i].removeAllItems();
		}

		value2.setVisible(false);

	}

	public Vector<String> getTraits() {
		return traits;
	}

	public void setTraits(Vector<String> traits) {
		this.traits = traits;
		traitModel.removeAllElements();
		if (traits != null) {
			for (String trait : traits) {
				traitModel.addElement(trait);
			}
		}
	}

	public HashMap<String, Vector<String>> getValues() {
		return values;
	}

	public void setValues(HashMap<String, Vector<String>> values) {
		this.values = values;
	}

	public String getTrait() {
		return traitModel.getSelectedItem().toString();
	}

	public int getComperator() {
		return mode.getSelectedIndex();
	}

	public String getMinValue() {
		return value.getSelectedItem().toString();
	}

	public String getMaxValue() {
		return "";
	}

	public void itemStateChanged(ItemEvent e) {
		JComboBox selectedChoice = (JComboBox) e.getSource();

		if (selectedChoice.equals(mode)) {
			if (selectedChoice.getSelectedIndex() > 3) {
				value2.setVisible(true);
				container.updateUI();
			} else {
				value2.setVisible(false);
				container.updateUI();
			}
		}

		if (selectedChoice.equals(trait)) {
			if (traitModel.getSelectedItem() != null) {
				value.removeAllItems();
				value2.removeAllItems();
				// maxField[i].removeAllItems();
				if (values != null) {
					if (values.get(traitModel.getSelectedItem().toString()) != null)
						for (Object o : values.get(traitModel.getSelectedItem()
								.toString())) {
							value.addItem(o.toString());
							value2.addItem(o.toString());
							// maxField[i].addItem(o.toString());
						}

				}

			}
		}

	}

	public void setEnabled(boolean enabled) {
		value.setEnabled(enabled);
		mode.setEnabled(enabled);
		trait.setEnabled(enabled);

	}

}
