package view.tools;

import javax.swing.*;
import javax.swing.border.EmptyBorder;

import java.util.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import core.*;

public class TraitPanel implements PanelListItem{

	String[] modes = new String[] { "equals", "not equals", "greater", "lesser",
			"between", "not between" };
	
	Vector<String> traits;
	
	HashMap<String,Vector<String>> values;
	
	DefaultComboBoxModel traitModel;

	JButton colorButton;
	
	public TraitPanel(){
		traitModel = new DefaultComboBoxModel();

	}
	
	

	public void createUI(JPanel container) {
		GridBagLayout layout = new GridBagLayout();
		container.setLayout(layout);
		//setBorder(new EmptyBorder(2,2,2,2));
		GridBagConstraints constLabel = new GridBagConstraints();
		constLabel.ipadx = 3;
		constLabel.gridx = 0;
		constLabel.gridy = 0;
		constLabel.weightx = 1;
		constLabel.weighty = 0;
		constLabel.insets = new Insets(2,2,2,2);
		constLabel.fill = GridBagConstraints.HORIZONTAL;

		JComboBox trait = new JComboBox();
		trait.setModel(traitModel);
		container.add(trait, constLabel);
		constLabel.weightx = 0.5;
		JComboBox value = new JComboBox();
		constLabel.gridx = 1;
		container.add(value, constLabel);
		colorButton = new JButton();
		colorButton.setBorderPainted(false);
		colorButton.addActionListener(new ActionListener() {
		
			public void actionPerformed(ActionEvent arg0) {
				// Set up the dialog that the button brings up.
				JColorChooser colorChooser = new JColorChooser();
				JDialog dialog = JColorChooser.createDialog(colorButton, "Pick a Color", true, // modal
						colorChooser, this, null);
				dialog.setVisible(true);
			}
		
		});
		constLabel.weightx = 0;
		constLabel.weighty = 1;
		constLabel.gridx = 2;
		container.add(colorButton, constLabel);
	}

	public Vector<String> getTraits() {
		return traits;
	}

	public void setTraits(Vector<String> traits) {
		this.traits = traits;
		traitModel.removeAllElements();
		if (traits != null){
		for (String trait: traits) {
			traitModel.addElement(trait);
		}		
		}
	}

	public HashMap<String, Vector<String>> getValues() {
		return values;
	}

	public void setValues(HashMap<String, Vector<String>> values) {
		this.values = values;
	}
	
}
